/***************************************************************************
                          dcconfig.cpp  -  description
                             -------------------
    begin                : Fri Mar 1 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>

#include <qstringlist.h>
#include <qregexp.h>
#include <qprocess.h>
#include <qsound.h>
#include <qpixmap.h>
#include <qimage.h>

#include <dclib/cbytearray.h>
#include <dclib/cstring.h>
#include <dclib/cthread.h>
#include <dclib/dcobject.h>
#include <dclib/che3.h>
#include <dclib/cxml.h>
#include <dclib/csocket.h>
#include <dclib/cstringlist.h>

// icons
#include "res/icon_operator.xpm"
#include "res/icon_user.xpm"
#include "res/icon_user_away.xpm"

#include "dcconfig.h"

#include <dclib/dcos.h>

// config files
#define DCGUI_CONFIG		"dcgui.cfg"
#define DCGUI_HUBFILTER		"dchubfilter.cfg"

#define XML_DCGUI_CONFIG	"dcgui"
#define XML_DCGUI_HUBFILTER	"dchubfilter"

#define XML_GUI				"gui"
#define XML_OPENPRIVATECHATWIN		"openprivatechatwindow"
#define XML_UNIT			"unit"
#define XML_THEME			"theme"
#define XML_LANGUAGEFILE		"languagefile"
#define XML_APP_FONT			"appfont"
#define XML_APP_WIDTH			"appwidth"
#define XML_APP_HEIGHT			"appheight"
#define XML_TV_WIDTH			"tvwidth"
#define XML_TV_HEIGHT			"tvheight"
#define XML_TV_DOCKED			"tvdocked"
#define XML_TOOLBAR			"toolbar"
#define XML_STATUSBAR			"statusbar"
#define XML_EXTERNAL_SOUND_PLAYER	"externalsoundplayer"
#define XML_EXTERNAL_PLAYER		"externalplayer"
#define XML_SOUND_FILE_CONNECT		"soundfileconnect"
#define XML_SOUND_FILE_DISCONNECT	"soundfiledisconnect"
#define XML_SOUND_FILE_SEND		"soundfilesend"
#define XML_SOUND_FILE_RECEIVE		"soundfilereceive"
#define XML_SOUND_FILE_FIRSTRECEIVE	"soundfilefirstreceive"
#define XML_SOUND_ENABLED_CONNECT	"soundenabledconnect"
#define XML_SOUND_ENABLED_DISCONNECT	"soundenableddisconnect"
#define XML_SOUND_ENABLED_SEND		"soundenabledsend"
#define XML_SOUND_ENABLED_RECEIVE	"soundenabledreceive"
#define XML_SOUND_ENABLED_FIRSTRECEIVE	"soundenabledfirstreceive"
#define XML_SOUND_DISABLED		"sounddisabled"
#define XML_SOUND_DISABLED_AWAY		"sounddisabledaway"
#define XML_TIMESTAMP_PRIVATECHAT	"timestampprivatechat"
#define XML_TIMESTAMP_HUBCHAT		"timestamphubchat"
#define XML_SHOW_STATUS_MESSAGE		"showstatusmessage"
#define XML_SHOW_TRANSFER_WIN		"showtransferwin"
#define XML_SEND_HIDE_PRIVATE_CHAT_TO_PUBLIC_CHAT "sendhideprivatechattopublicchat"
#define XML_CHAT_MESSAGE_MAX_LINES	"chatmessagemaxlines"
#define XML_DEFAULTDOWNLOADMODE		"defaultdownloadmode"
#define XML_EMOTICONS			"emoticons"
#define XML_SENDCHAT			"sendchat"
#define XML_QUERYONEXIT			"queryonexit"
#define XML_SHOWCHATSENDBUTTON		"showchatsendbutton"
#define XML_CHATMAXPARAGRAPH		"chatmaxparagraph"

#define XML_TV_CHUNKPERCENT		"tvchunkpercent"
#define XML_TV_FILEPERCENT		"tvfilepercent"
#define XML_TV_CHUNKSIZE		"tvchunksize"
#define XML_TV_FILESIZE			"tvfilesize"
#define XML_TV_DOWNLOADRATESINGLE	"tvdownloadratesingle"
#define XML_TV_ELAPSEDTIMESINGLE	"tvelapsedtimesingle"
#define XML_TV_DOWNLOADRATEMULTI	"tvdownloadratemulti"
#define XML_TV_ELAPSEDTIMEMULTI		"tvelapsedtimemulti"

#define XML_NAME			"name"
#define XML_ENTRY			"entry"
#define XML_SECTION			"section"
#define XML_SIZE			"size"
#define XML_POS				"pos"

#define XML_FILTER			"filter"
#define XML_FILTERNAME			"filtername"
#define XML_CONTAINS			"contains"
#define XML_USER			"user"
#define XML_SERVER			"server"
#define XML_DESCRIPTION			"description"
#define XML_VERSION_TAG			"versiontag"
#define XML_USERLISTRIGHTALIGNMENT	"userlistrightalignment"
#define XML_BACKGROUNDPIXMAP		"backgroundpixmap"
#define XML_BROWSER			"browser"
#define XML_SHOWCHATINTAB		"showchatintab"
#define XML_CHATCOLORREMOTETEXT		"chatcolorremotetext"
#define XML_CHATCOLORREMOTENICK		"chatcolorremotenick"
#define XML_OPENCLIENTWINDOWSMINIMIZED	"openclientwindowsminimized"

#define XML_FLOODCOUNT			"floodcount"
#define XML_FLOODOPKICK			"floodopkick"
#define XML_FLOODKICKMESSAGE		"floodkickmessage"

#define XML_UNIT_AUTO	"auto"
#define XML_UNIT_BYTE	"byte"
#define XML_UNIT_KBYTE	"kbyte"
#define XML_UNIT_MBYTE	"mbyte"
#define XML_UNIT_GBYTE	"gbyte"

DCConfig * Config = 0;

DCConfig::DCConfig( CString configpath ) : CConfig(configpath)
{
	// gui defaults
	bOpenPrivateChatWindow	= TRUE;
	euUnit			= euAUTO;
	sTheme			= "Default";
	sLanguageFile		= "";
	sAppFont		= DEFAULT_APP_FONT;
	iAppHeight		= 480;
	iAppWidth		= 640;
	iTransferViewHeight     = 100;
	iTransferViewWidth      = 640;
	bTransferViewDocked     = TRUE;
	bToolBar		= TRUE;
	bStatusBar		= TRUE;

	sSoundFileConnect	= "";
	sSoundFileDisconnect	= "";
	sSoundFileSend		= "";
	sSoundFileReceive	= "";
	sSoundFileFirstReceive	= "";

	bSoundDisabled		= TRUE;
	bSoundDisabledAway	= TRUE;

	bSoundEnabledConnect	= TRUE;
	bSoundEnabledDisconnect	= TRUE;
	bSoundEnabledSend	= TRUE;
	bSoundEnabledReceive	= TRUE;
	bSoundEnabledFirstReceive = TRUE;

	bEnableEmoticons        = TRUE;
	bTimeStampPrivateChat	= TRUE;
	bTimeStampHubChat	= TRUE;
	bShowStatusMessage      = TRUE;
	bShowTransferWin        = FALSE;
	sSendChat		= "Enter";

	bExternalSoundPlayer	= FALSE;
	sExternalPlayer		= "";

	bTVChunkPercent         = TRUE;
	bTVFilePercent          = TRUE;
	bTVChunkSize            = TRUE;
	bTVFileSize             = TRUE;
	bTVDownloadRateSingle   = TRUE;
	bTVElapsedTimeSingle    = TRUE;
	bTVDownloadRateMulti    = TRUE;
	bTVElapsedTimeMulti     = TRUE;
	bThemeSupport           = TRUE;
	bShowVersionTag         = TRUE;
	bUserListRightAlignment = TRUE;

	bSendHidePrivateChatToPublicChat = TRUE;

	iChatMessageMaxLines = 0;
	
	iFloodCount    = 3;
	m_bFloodOpKick = FALSE;
	
	m_pMimeSourceFactory = 0;

	pProcess = new QProcess ();

	icon_operator = QPixmap(icon_operator_xpm);
	icon_user = QPixmap(icon_user_xpm);
	icon_user_away = QPixmap(icon_user_away_xpm);

	iDefaultDownloadMode = 0;

	bQueryOnExit = FALSE;
	bShowChatSendButton = TRUE;
	sBackgroundPixmap = "";
	sBrowser = "konqueror";
	bShowChatInTab = TRUE;
	sChatColorRemoteText = "#000000";
	sChatColorRemoteNick = "#000000";
	m_nChatMaxParagraph = 0;
	bOpenClientWindowsMinimized = FALSE;
	m_EmoticonSettingList = 0;

	Config = this;
}

DCConfig::~DCConfig()
{
	delete pProcess;

	if ( m_pMimeSourceFactory )
	{
		QMimeSourceFactory::removeFactory(m_pMimeSourceFactory);
		delete m_pMimeSourceFactory;
	}

	if ( m_EmoticonSettingList )
	{
		delete m_EmoticonSettingList;
	}

	m_guiSettingMap.clear();

	m_EmoticonImage.reset();
}

/** */
void DCConfig::ParseDCGuiConfig( xmlNodePtr node )
{
	xmlNodePtr n1,n2,n3,n4;
	CXml xml;

	for(n1=node;n1!=0;n1=n1->next)
	{
		/* gui entrys */
		if ( xml.name(n1) == XML_GUI )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml.name(n2) == XML_OPENCLIENTWINDOWSMINIMIZED )
					bOpenClientWindowsMinimized = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_OPENPRIVATECHATWIN )
					bOpenPrivateChatWindow = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_CHATMAXPARAGRAPH )
					m_nChatMaxParagraph = xml.content(n2).asLONG();
				else if ( xml.name(n2) == XML_EMOTICONS )
				        bEnableEmoticons = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_VERSION_TAG )
				        bShowVersionTag = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TOOLBAR )
				        bToolBar = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_STATUSBAR )
					bStatusBar = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_USERLISTRIGHTALIGNMENT )
					bUserListRightAlignment = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SHOWCHATSENDBUTTON )
					bShowChatSendButton = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_CHATCOLORREMOTETEXT )
					sChatColorRemoteText = xml.content(n2);
				else if ( xml.name(n2) == XML_CHATCOLORREMOTENICK )
					sChatColorRemoteNick = xml.content(n2);
				else if ( xml.name(n2) == XML_UNIT )
				{
					if ( xml.content(n2) == XML_UNIT_AUTO )
						euUnit = euAUTO;
					else if ( xml.content(n2) == XML_UNIT_BYTE )
						euUnit = euBYTE;
					else if ( xml.content(n2) == XML_UNIT_KBYTE )
						euUnit = euKBYTE;
					else if ( xml.content(n2) == XML_UNIT_MBYTE )
						euUnit = euMBYTE;
					else if ( xml.content(n2) == XML_UNIT_GBYTE )
						euUnit = euGBYTE;
				}
				else if ( xml.name(n2) == XML_THEME )
					sTheme = xml.content(n2);
				else if ( xml.name(n2) == XML_BACKGROUNDPIXMAP )
					sBackgroundPixmap = xml.content(n2);
				else if ( xml.name(n2) == XML_BROWSER )
					sBrowser = xml.content(n2);
				else if ( xml.name(n2) == XML_LANGUAGEFILE )
					sLanguageFile = xml.content(n2);
				else if ( xml.name(n2) == XML_APP_FONT )
					sAppFont = xml.content(n2);
				else if ( xml.name(n2) == XML_APP_WIDTH )
					iAppWidth = xml.content(n2).asINT();
				else if ( xml.name(n2) == XML_APP_HEIGHT )
					iAppHeight = xml.content(n2).asINT();
				else if ( xml.name(n2) == XML_TV_WIDTH )
					iTransferViewWidth = xml.content(n2).asINT();
				else if ( xml.name(n2) == XML_TV_HEIGHT )
					iTransferViewHeight = xml.content(n2).asINT();
				else if ( xml.name(n2) == XML_TV_DOCKED )
					bTransferViewDocked = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SOUND_FILE_CONNECT )
					sSoundFileConnect = xml.content(n2);
				else if ( xml.name(n2) == XML_SOUND_FILE_DISCONNECT )
					sSoundFileDisconnect = xml.content(n2);
				else if ( xml.name(n2) == XML_SOUND_FILE_SEND )
					sSoundFileSend = xml.content(n2);
				else if ( xml.name(n2) == XML_SOUND_FILE_RECEIVE )
					sSoundFileReceive = xml.content(n2);
				else if ( xml.name(n2) == XML_SOUND_FILE_FIRSTRECEIVE )
					sSoundFileFirstReceive = xml.content(n2);
				else if ( xml.name(n2) == XML_EXTERNAL_SOUND_PLAYER )
					bExternalSoundPlayer = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_EXTERNAL_PLAYER )
					sExternalPlayer = xml.content(n2);
				else if ( xml.name(n2) == XML_SOUND_DISABLED )
					bSoundDisabled = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SOUND_DISABLED_AWAY )
					bSoundDisabledAway = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SOUND_ENABLED_CONNECT )
					bSoundEnabledConnect = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SOUND_ENABLED_DISCONNECT )
					bSoundEnabledDisconnect = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SOUND_ENABLED_SEND )
					bSoundEnabledSend = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SOUND_ENABLED_RECEIVE )
					bSoundEnabledReceive = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SOUND_ENABLED_FIRSTRECEIVE )
					bSoundEnabledFirstReceive = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TIMESTAMP_PRIVATECHAT )
					bTimeStampPrivateChat = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TIMESTAMP_HUBCHAT )
					bTimeStampHubChat = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SHOW_STATUS_MESSAGE )
					bShowStatusMessage = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SENDCHAT )
					sSendChat = xml.content(n2);
				else if ( xml.name(n2) == XML_SHOW_TRANSFER_WIN )
					bShowTransferWin = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_CHUNKPERCENT )
					bTVChunkPercent = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_FILEPERCENT )
					bTVFilePercent = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_CHUNKSIZE )
					bTVChunkSize = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_FILESIZE )
					bTVFileSize = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_DOWNLOADRATESINGLE )
					bTVDownloadRateSingle = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_ELAPSEDTIMESINGLE )
					bTVElapsedTimeSingle = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_DOWNLOADRATEMULTI )
					bTVDownloadRateMulti = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_TV_ELAPSEDTIMEMULTI )
					bTVElapsedTimeMulti = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SEND_HIDE_PRIVATE_CHAT_TO_PUBLIC_CHAT )
					bSendHidePrivateChatToPublicChat = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_CHAT_MESSAGE_MAX_LINES )
					iChatMessageMaxLines = xml.content(n2).asINT();
				else if ( xml.name(n2) == XML_FLOODCOUNT )
					iFloodCount = xml.content(n2).asINT();
				else if ( xml.name(n2) == XML_FLOODOPKICK )
					m_bFloodOpKick = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_DEFAULTDOWNLOADMODE )
					iDefaultDownloadMode = xml.content(n2).asINT();
				else if ( xml.name(n2) == XML_QUERYONEXIT )
					bQueryOnExit = xml.getBoolChild(n2);
				else if ( xml.name(n2) == XML_SHOWCHATINTAB )
					bShowChatInTab = xml.getBoolChild(n2);
				else if ( xml.name(n2) == "MAP" )
				{
					StringMap * map = new StringMap();

					for(n3=n2->xmlChildrenNode;n3!=0;n3=n3->next)
					{
						if ( xml.name(n3) == "KEY" )
							m_guiSettingMap[xml.content(n3).Data()] = map;
						else if ( xml.name(n3) == XML_ENTRY )
						{
							CString key="",name="";
							for(n4=n3->xmlChildrenNode;n4!=0;n4=n4->next)
							{
								if ( xml.name(n4) == "KEY" )
									key = xml.content(n4);
								else if ( xml.name(n4) == "NAME" )
									name = xml.content(n4);
							}
							(*map)[key.Data()]=name.Data();
						}
					}
				}
			}
		}
	}
}

/** */
int DCConfig::Load()
{
	LoadHubProfile();
	LoadDCLib();
	return LoadDCGui();
}

/** */
int DCConfig::Save()
{
	SaveDCLib();
	return SaveDCGui();
}

/** */
int DCConfig::LoadDCGui()
{
	int err = 0;
	CString s;
	xmlNodePtr node;
	CXml xml;

	s = sConfigPath + DCGUI_CONFIG;

	if ( xml.ParseFile(s) == TRUE )
	{
		for(node=xml.doc()->children;node!=0;node=node->next)
		{
			if ( xml.name(node) == XML_DCGUI_CONFIG )
			{
				ParseDCGuiConfig(node->xmlChildrenNode);
			}
		}
	}
	else
	{
		err = -1;
	}

	InitMimeSourceFactory();

	return err;
}

/** */
int DCConfig::SaveDCGui()
{
	int err=0;
	CString s;
	xmlDocPtr doc;
	xmlNodePtr node,node1,node2;
	CXml xml;

	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCGUI_CONFIG,0);

	// gui
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_GUI, 0 );

	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_OPENCLIENTWINDOWSMINIMIZED, bOpenClientWindowsMinimized );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_OPENPRIVATECHATWIN, bOpenPrivateChatWindow );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_VERSION_TAG, bShowVersionTag );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_EMOTICONS, bEnableEmoticons );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TOOLBAR, bToolBar );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_STATUSBAR, bStatusBar );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_USERLISTRIGHTALIGNMENT, bUserListRightAlignment );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SHOWCHATSENDBUTTON, bShowChatSendButton );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SHOWCHATINTAB, bShowChatInTab );
	xmlNewChild( node, 0, (const xmlChar*)XML_CHATCOLORREMOTETEXT, (const xmlChar*) xml.ToUTF8(sChatColorRemoteText).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_CHATCOLORREMOTENICK, (const xmlChar*) xml.ToUTF8(sChatColorRemoteNick).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_CHATMAXPARAGRAPH, (const xmlChar*) CString().setNum(m_nChatMaxParagraph).Data() );

	switch(euUnit)
	{
		case euBYTE:
			s = XML_UNIT_BYTE;
			break;
		case euKBYTE:
			s = XML_UNIT_KBYTE;
			break;
		case euMBYTE:
			s = XML_UNIT_MBYTE;
			break;
		case euGBYTE:
			s = XML_UNIT_GBYTE;
			break;
		default:
			s = XML_UNIT_AUTO;
			break;
	}

	xmlNewChild( node, 0, (const xmlChar*)XML_UNIT, (const xmlChar*)(const char*)s.Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_THEME, (const xmlChar*) xml.ToUTF8(sTheme).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_BACKGROUNDPIXMAP, (const xmlChar*) xml.ToUTF8(sBackgroundPixmap).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_BROWSER, (const xmlChar*) xml.ToUTF8(sBrowser).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_SENDCHAT, (const xmlChar*) xml.ToUTF8(sSendChat).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_LANGUAGEFILE, (const xmlChar*) xml.ToUTF8(sLanguageFile).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_APP_FONT, (const xmlChar*) xml.ToUTF8(sAppFont).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_APP_WIDTH, (const xmlChar*) CString().setNum(iAppWidth).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_APP_HEIGHT, (const xmlChar*) CString().setNum(iAppHeight).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_TV_WIDTH, (const xmlChar*) CString().setNum(iTransferViewWidth).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_TV_HEIGHT, (const xmlChar*) CString().setNum(iTransferViewHeight).Data() );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_DOCKED, bTransferViewDocked );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_QUERYONEXIT, bQueryOnExit );

	// sound settings
	xmlNewChild( node, 0, (const xmlChar*)XML_SOUND_FILE_CONNECT, (const xmlChar*) xml.ToUTF8(sSoundFileConnect).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_SOUND_FILE_DISCONNECT, (const xmlChar*) xml.ToUTF8(sSoundFileDisconnect).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_SOUND_FILE_SEND, (const xmlChar*) xml.ToUTF8(sSoundFileSend).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_SOUND_FILE_RECEIVE, (const xmlChar*) xml.ToUTF8(sSoundFileReceive).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_SOUND_FILE_FIRSTRECEIVE, (const xmlChar*) xml.ToUTF8(sSoundFileFirstReceive).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_EXTERNAL_PLAYER, (const xmlChar*) xml.ToUTF8(sExternalPlayer).Data() );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SOUND_ENABLED_CONNECT, bSoundEnabledConnect );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SOUND_ENABLED_DISCONNECT, bSoundEnabledDisconnect );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SOUND_ENABLED_SEND, bSoundEnabledSend );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SOUND_ENABLED_RECEIVE, bSoundEnabledReceive );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SOUND_ENABLED_FIRSTRECEIVE, bSoundEnabledFirstReceive );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_EXTERNAL_SOUND_PLAYER, bExternalSoundPlayer );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SOUND_DISABLED, bSoundDisabled );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SOUND_DISABLED_AWAY, bSoundDisabledAway );

	// log settings
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TIMESTAMP_PRIVATECHAT, bTimeStampPrivateChat );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TIMESTAMP_HUBCHAT, bTimeStampHubChat );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SHOW_STATUS_MESSAGE, bShowStatusMessage );

	// transfer view settings
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_CHUNKPERCENT, bTVChunkPercent );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_FILEPERCENT, bTVFilePercent );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_CHUNKSIZE, bTVChunkSize );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_FILESIZE, bTVFileSize );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_DOWNLOADRATESINGLE, bTVDownloadRateSingle );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_ELAPSEDTIMESINGLE, bTVElapsedTimeSingle );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_DOWNLOADRATEMULTI, bTVDownloadRateMulti );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_TV_ELAPSEDTIMEMULTI, bTVElapsedTimeMulti );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SHOW_TRANSFER_WIN, bShowTransferWin );
	
	xmlNewChild( node, 0, (const xmlChar*)XML_FLOODCOUNT, (const xmlChar*) CString().setNum(iFloodCount).Data() );
	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_FLOODOPKICK, m_bFloodOpKick );

	xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SEND_HIDE_PRIVATE_CHAT_TO_PUBLIC_CHAT, bSendHidePrivateChatToPublicChat );
	xmlNewChild( node, 0, (const xmlChar*)XML_CHAT_MESSAGE_MAX_LINES, (const xmlChar*) CString().setNum(iChatMessageMaxLines).Data() );
	xmlNewChild( node, 0, (const xmlChar*)XML_DEFAULTDOWNLOADMODE, (const xmlChar*) CString().setNum(iDefaultDownloadMode).Data() );

	// save map settings
	SettingMap::Iterator it;
	StringMap::Iterator it1;

	for(it=m_guiSettingMap.begin();it!=m_guiSettingMap.end();++it)
	{
		node1 = xmlNewChild( node, 0, (const xmlChar*)"MAP", 0 );
		xmlNewChild( node1, 0, (const xmlChar*)"KEY", (const xmlChar*) xml.ToUTF8(it.key().ascii()).Data() );
		for(it1=it.data()->begin();it1!=it.data()->end();++it1)
		{
			node2 = xmlNewChild( node1, 0, (const xmlChar*)XML_ENTRY, 0 );
			xmlNewChild( node2, 0, (const xmlChar*)"KEY", (const xmlChar*) xml.ToUTF8(it1.key().ascii()).Data() );
			xmlNewChild( node2, 0, (const xmlChar*)"NAME", (const xmlChar*) xml.ToUTF8(it1.data().ascii()).Data() );
		}
	}

	// save file
	s = sConfigPath + DCGUI_CONFIG;

	if ( xmlSaveFormatFile(s.Data(),doc,1) == -1 )
	{
		err = -1;
	}

	xmlFreeDoc(doc);

	return err;
}

/** */
int DCConfig::LoadDCHubFilter( CStringList * list )
{
	CString s;
	xmlNodePtr node,n1,n2;
	CXml xml;
	DC_HubFilterObject * HubFilterObject;

	s = sConfigPath + DCGUI_HUBFILTER;

	if ( xml.ParseFile(s) == TRUE )
	{
		for(node=xml.doc()->children;node!=0;node=node->next)
		{
			if ( xml.name(node) == XML_DCGUI_HUBFILTER )
			{
				for(n1=node->xmlChildrenNode;n1!=0;n1=n1->next)
				{
					if ( xml.name(n1) == XML_FILTER )
					{
						HubFilterObject = new DC_HubFilterObject();

						for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
						{
							if ( xml.name(n2) == XML_FILTERNAME )
								HubFilterObject->m_sFilterName = xml.content(n2);
							else if ( xml.name(n2) == XML_CONTAINS )
								HubFilterObject->m_sContains = xml.content(n2);
							else if ( xml.name(n2) == XML_USER )
								HubFilterObject->m_nUser = xml.content(n2).asINT();
							else if ( xml.name(n2) == XML_NAME )
								HubFilterObject->m_bName = xml.getBoolChild(n2);
							else if ( xml.name(n2) == XML_SERVER )
								HubFilterObject->m_bServer = xml.getBoolChild(n2);
							else if ( xml.name(n2) == XML_DESCRIPTION )
								HubFilterObject->m_bDescription = xml.getBoolChild(n2);
						}

						if ( HubFilterObject->m_sFilterName != "" )
							list->Add( HubFilterObject->m_sFilterName, HubFilterObject );
						else
							delete HubFilterObject;
					}
				}
			}
		}
	}

	return 0;
}

/** */
int DCConfig::SaveDCHubFilter( CStringList * list )
{
	int err=0;
	CString s;
	xmlDocPtr doc;
	DC_HubFilterObject * HubFilterObject;
	xmlNodePtr node;
	CXml xml;

	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCGUI_HUBFILTER,0);

	HubFilterObject = 0;

	while( list->Next((CObject *&)HubFilterObject) == 1 )
	{
		node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_FILTER, 0 );

		xmlNewChild( node, 0, (const xmlChar*)XML_FILTERNAME, (const xmlChar*) xml.ToUTF8(HubFilterObject->m_sFilterName).Data() );
		xmlNewChild( node, 0, (const xmlChar*)XML_CONTAINS, (const xmlChar*) xml.ToUTF8(HubFilterObject->m_sContains).Data() );
		xmlNewChild( node, 0, (const xmlChar*)XML_USER, (const xmlChar*) CString().setNum(HubFilterObject->m_nUser).Data() );
		xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_NAME, HubFilterObject->m_bName );
		xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_SERVER, HubFilterObject->m_bServer );
		xml.xmlNewBoolChild( node, 0, (const xmlChar*)XML_DESCRIPTION, HubFilterObject->m_bDescription );
	}

	// save file
	s = sConfigPath + DCGUI_HUBFILTER;

	if ( xmlSaveFormatFile(s.Data(),doc,1) == -1 )
	{
		err = -1;
	}

	xmlFreeDoc(doc);

	return err;
}

/** */
QPixmap & DCConfig::GetUserIcon( eUserIconType type )
{
	switch(type)
	{
		case euitOPERATOR:
			return icon_operator;
			break;
		case euitUSER_AWAY:
			return icon_user_away;
			break;
		case euitUSER:
		default:
			return icon_user;
			break;
	}
}

/** */
CString DCConfig::GetSoundFile( eUserSound usersound )
{
	Thread.Lock();

	CString s;

	switch (usersound)
	{
		case eusCONNECT:
			s = sSoundFileConnect;
			break;
		case eusDISCONNECT:
			s = sSoundFileDisconnect;
			break;
		case eusSEND:
			s = sSoundFileSend;
			break;
		case eusRECEIVE:
			s = sSoundFileReceive;
			break;
		case eusFIRSTRECEIVE:
			s = sSoundFileFirstReceive;
			break;
		default:
			s = "";
			break;
	}

	Thread.UnLock();

	return s;
}

/** */
void DCConfig::SetSoundFile( eUserSound usersound, CString soundfile )
{
	Thread.Lock();

	switch (usersound)
	{
		case eusCONNECT:
			sSoundFileConnect = soundfile;
			break;
		case eusDISCONNECT:
			sSoundFileDisconnect = soundfile;
			break;
		case eusSEND:
			sSoundFileSend = soundfile;
			break;
		case eusRECEIVE:
			sSoundFileReceive = soundfile;
			break;
		case eusFIRSTRECEIVE:
			sSoundFileFirstReceive = soundfile;
			break;
		default:
			break;
	}

	Thread.UnLock();
}

/** */
bool DCConfig::GetSoundEnabled( eUserSound usersound )
{
	Thread.Lock();

	bool b;

	switch (usersound)
	{
		case eusCONNECT:
			b = bSoundEnabledConnect;
			break;
		case eusDISCONNECT:
			b = bSoundEnabledDisconnect;
			break;
		case eusSEND:
			b = bSoundEnabledSend;
			break;
		case eusRECEIVE:
			b = bSoundEnabledReceive;
			break;
		case eusFIRSTRECEIVE:
			b = bSoundEnabledFirstReceive;
			break;
		default:
			b = FALSE;
			break;
	}

	Thread.UnLock();

	return b;
}

/** */
void DCConfig::SetSoundEnabled( eUserSound usersound, bool enabled )
{
	Thread.Lock();

	switch (usersound)
	{
		case eusCONNECT:
			bSoundEnabledConnect = enabled;
			break;
		case eusDISCONNECT:
			bSoundEnabledDisconnect = enabled;
			break;
		case eusSEND:
			bSoundEnabledSend = enabled;
			break;
		case eusRECEIVE:
			bSoundEnabledReceive = enabled;
			break;
		case eusFIRSTRECEIVE:
			bSoundEnabledFirstReceive = enabled;
			break;
		default:
			break;
	}

	Thread.UnLock();
}

/** */
void DCConfig::PlaySound( eUserSound usersound )
{
	CString s = "";

	if ( bSoundDisabled == TRUE )
	{
		return;
	}

	if ( (GetAwayMode() == euamAWAY) && (bSoundDisabledAway == TRUE) )
	{
		return;
	}

	switch(usersound)
	{
		case eusCONNECT:
			if ( bSoundEnabledConnect )
				s = sSoundFileConnect;
			break;
		case eusDISCONNECT:
			if ( bSoundEnabledDisconnect )
				s = sSoundFileDisconnect;
			break;
		case eusSEND:
			if ( bSoundEnabledSend )
				s = sSoundFileSend;
			break;
		case eusRECEIVE:
			if ( bSoundEnabledReceive )
				s = sSoundFileReceive;
			break;
		case eusFIRSTRECEIVE:
			if ( bSoundEnabledFirstReceive )
				s = sSoundFileFirstReceive;
			break;
		default:
			break;
	}

	PlaySound(s);
}

/** */
void DCConfig::PlaySound( CString file )
{
	if ( file == "" )
	{
		return;
	}

	if ( bExternalSoundPlayer == FALSE )
	{
		QSound::play(file.Data());
	}
	else
	{
		if ( pProcess->isRunning() == TRUE )
		{
			pProcess->kill();
		}

		pProcess->clearArguments();

		pProcess->addArgument(sExternalPlayer.Data());
		pProcess->addArgument(file.Data());

		if ( !pProcess->start() )
		{
			printf("error start play process\n");
		}
	}
}

/** */
void DCConfig::SetTimeStamp( eTimeStamp timestamp, bool enabled )
{
	Thread.Lock();

	switch(timestamp)
	{
		case etsPRIVATECHAT:
			bTimeStampPrivateChat = enabled;
			break;
		case etsHUBCHAT:
			bTimeStampHubChat = enabled;
			break;
		default:
			break;
	}

	Thread.UnLock();
}

/** */
bool DCConfig::GetTimeStamp( eTimeStamp timestamp )
{
	Thread.Lock();

	bool res;

	switch(timestamp)
	{
		case etsPRIVATECHAT :
			res = bTimeStampPrivateChat;
			break;
		case etsHUBCHAT:
			res = bTimeStampHubChat;
			break;
		default:
			res = FALSE;
			break;
	}

	Thread.UnLock();

	return res;
}

/** */
bool DCConfig::GetTransferViewOptions( eTransferViewOptions e ) const
{
	switch(e)
	{
		case etvoCHUNKPERCENT:
			return bTVChunkPercent;
			break;
		case etvoFILEPERCENT:
			return bTVFilePercent;
			break;		
		case etvoCHUNKSIZE:
			return bTVChunkSize;
			break;		
		case etvoFILESIZE:
			return bTVFileSize;
			break;		
		case etvoDOWNLOADRATESINGLE:
			return bTVDownloadRateSingle;
			break;		
		case etvoELAPSEDTIMESINGLE:
			return bTVElapsedTimeSingle;
			break;		
		case etvoDOWNLOADRATEMULTI:
			return bTVDownloadRateMulti;
			break;		
		case etvoELAPSEDTIMEMULTI:
			return bTVElapsedTimeMulti;
			break;		
		default:
			return FALSE;
			break;
	}
}

/** */
void DCConfig::SetTransferViewOptions( eTransferViewOptions e, bool b )
{
  	switch(e)
	{
		case etvoCHUNKPERCENT:
			bTVChunkPercent = b;
			break;
		case etvoFILEPERCENT:
			bTVFilePercent = b;
			break;		
		case etvoCHUNKSIZE:
			bTVChunkSize = b;
			break;		
		case etvoFILESIZE:
			bTVFileSize = b;
			break;		
		case etvoDOWNLOADRATESINGLE:
			bTVDownloadRateSingle = b;
			break;		
		case etvoELAPSEDTIMESINGLE:
			bTVElapsedTimeSingle = b;
			break;		
		case etvoDOWNLOADRATEMULTI:
			bTVDownloadRateMulti = b;
			break;		
		case etvoELAPSEDTIMEMULTI:
			bTVElapsedTimeMulti = b;
			break;		
		default:
			break;
	}
}

/** */
bool DCConfig::InitMimeSourceFactory()
{
	DC_EmoticonObject * EmoticonObject;
	CString s,imagename;
	xmlNodePtr node,n1,n2;
	CXml xml;
	int id;
	bool res = FALSE;

	if ( m_pMimeSourceFactory )
	{
		QMimeSourceFactory::removeFactory(m_pMimeSourceFactory);
		delete m_pMimeSourceFactory;
		m_pMimeSourceFactory = 0;
	}

	m_EmoticonImage.reset();

	if ( m_EmoticonSettingList )
	{
		delete m_EmoticonSettingList;
	}

	m_EmoticonSettingList = new CList<DC_EmoticonObject>();

	// load emoticons
	s = GetDatadir()+DIRSEPARATOR+"emoticons"+DIRSEPARATOR;

	if ( xml.ParseFile(s+"emotes.xml") == FALSE )
	{
		return res;
	}

	id = 0;

	// parse the list
	for(node=xml.doc()->children;node!=0;node=node->next)
	{
		if ( xml.name(node) == "emoticons" )
		{
			for(n1=node->xmlChildrenNode;n1!=0;n1=n1->next)
			{
				if ( xml.name(n1) == "emoticon" )
				{
					EmoticonObject = new DC_EmoticonObject();

					EmoticonObject->m_Text = xml.prop(n1,"text").Data();

					for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
					{
						if ( xml.name(n2) == "source" )
						{
							EmoticonObject->left   = xml.prop(n2,"left").asINT();
							EmoticonObject->top    = xml.prop(n2,"top").asINT();
							EmoticonObject->right  = xml.prop(n2,"right").asINT();
							EmoticonObject->bottom = xml.prop(n2,"bottom").asINT();

							imagename = xml.prop(n2,"name") + ".xpm";
						}
					}

					if ( EmoticonObject->m_Text != "" )
					{
							EmoticonObject->m_nID = id;
							id++;
							m_EmoticonSettingList->Add(EmoticonObject);
					}
				}
			}
		}
	}

	if ( m_EmoticonImage.load((s+imagename).Data()) == TRUE )
	{
		res = TRUE;
	}
	else
	{
		if ( m_EmoticonSettingList )
		{
			delete m_EmoticonSettingList;
			m_EmoticonSettingList = 0;
		}
	}

	if ( m_EmoticonSettingList->Count() > 0 )
	{
		m_pMimeSourceFactory = new QMimeSourceFactory();

		EmoticonObject = 0;

		while( (EmoticonObject=m_EmoticonSettingList->Next(EmoticonObject)) != 0 )
		{
			m_pMimeSourceFactory->setImage( ("emoticon" + CString().setNum(EmoticonObject->m_nID)).Data(), 
				m_EmoticonImage.copy(EmoticonObject->left,EmoticonObject->top,EmoticonObject->right-EmoticonObject->left,EmoticonObject->bottom-EmoticonObject->top) );
		}

		QMimeSourceFactory::addFactory(m_pMimeSourceFactory);

		res = TRUE;
	}

	return res;
}

/** */
CList<DC_EmoticonObject> * DCConfig::EmoticonList()
{
	return m_EmoticonSettingList;
}

/** */
QImage & DCConfig::GetEmoticonImage()
{
	return m_EmoticonImage;
}

/** */
bool DCConfig::GetMap( CString name, StringMap *& map )
{
	bool res = TRUE;

	if ( m_guiSettingMap.find(name.Data()) == m_guiSettingMap.end() )
	{
		m_guiSettingMap[name.Data()] = new StringMap();
		res = FALSE;
	}

	map = m_guiSettingMap[name.Data()];

	return res;
}

/** */
CString DCConfig::GetChatColor( eChatColor type ) const
{
	switch (type)
	{
		case eccREMOTENICK:
			return sChatColorRemoteNick;
		case eccREMOTETEXT:
			return sChatColorRemoteText;
		default:
			break;
	}

	return "#000000";
}

/** */
void DCConfig::SetChatColor( eChatColor type, CString s )
{
	Thread.Lock();

	switch (type)
	{
		case eccREMOTENICK:
			sChatColorRemoteNick = s;
			break;
		case eccREMOTETEXT:
			sChatColorRemoteText = s;
			break;
		default:
			break;
	}

	Thread.UnLock();
}
