/***************************************************************************
                          dcoptions.cpp  -  description
                             -------------------
    begin                : Sun Feb 24 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qdir.h>
#include <qdialog.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qcombobox.h>
#include <qlistbox.h>
#include <qslider.h>
#include <qtabwidget.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qfiledialog.h>
#include <qlabel.h>
#include <qmessagebox.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qspinbox.h>
#include <qstylefactory.h>
#include <qapplication.h>
#include <qlistview.h>
#include <qinputdialog.h>
#include <qfontdialog.h>
#include <qlayout.h>
#include <qsound.h>
#include <qregexp.h>
#include <qcolordialog.h>
#include <qtoolbutton.h>

#include <dclib/cbytearray.h>
#include <dclib/cstring.h>
#include <dclib/che3.h>
#include <dclib/csocket.h>
#include <dclib/cfilemanager.h>

#include <dcbrowsefiletree.h>
#include <dcfiletool.h>
#include <dcfilebrowser.h>
#include "dcoptions.h"

#include <dclib/dcos.h>

#include "res/configure.xpm"

/** */
DCOptions::DCOptions()
{
	// set default icon
	setIcon( QPixmap( configure_xpm ) );

	InitDocument();
}

/** */
DCOptions::~DCOptions()
{
}

/** */
void DCOptions::InitDocument()
{
	// set width mode
	ListView_OPTIONTREE->setColumnWidthMode( 0, QListView::Maximum );
	// hide the column header
	ListView_OPTIONTREE->header()->hide();
	// disable sort
	ListView_OPTIONTREE->setSorting(-1);

	// setup the option tree
	plviSecurity = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviSecurity->setText( 0, tr( "Security" ) );

	plviOther = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviOther->setText( 0, tr( "Other" ) );

	plviLog = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviLog->setText( 0, tr( "Log" ) );

	plviSound = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviSound->setText( 0, tr( "Sound" ) );

	plviGUI = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviGUI->setText( 0, tr( "GUI" ) );
	plviGUIUser = new QListViewItem( plviGUI, 0 );
	plviGUIUser->setText( 0, tr( "User" ) );
	plviGUIChat = new QListViewItem( plviGUI, 0 );
	plviGUIChat->setText( 0, tr( "Chat" ) );
	plviGUITransfer = new QListViewItem( plviGUI, 0 );
	plviGUITransfer->setText( 0, tr( "Transfer" ) );
	plviGUIGeneral = new QListViewItem( plviGUI, 0 );
	plviGUIGeneral->setText( 0, tr( "General" ) );

	plviTransfer = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviTransfer->setText( 0, tr( "Transfer" ) );
	plviTransferSettings = new QListViewItem( plviTransfer, 0 );
	plviTransferSettings->setText( 0, tr( "Settings" ) );
	plviTransferFolder = new QListViewItem( plviTransfer, 0 );
	plviTransferFolder->setText( 0, tr( "Folder" ) );

	plviConnection = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviConnection->setText( 0, tr( "Connection" ) );
	plviConnectionSettings = new QListViewItem( plviConnection, 0 );
	plviConnectionSettings->setText( 0, tr( "Settings" ) );
	plviConnectionMode = new QListViewItem( plviConnection, 0 );
	plviConnectionMode->setText( 0, tr( "Mode" ) );

	plviDCGUI = new QListViewItem( ListView_OPTIONTREE, 0 );
	plviDCGUI->setText( 0, tr( "DCGUI" ) );
	plviDCGUIIdentify = new QListViewItem( plviDCGUI, 0 );
	plviDCGUIIdentify->setText( 0, tr( "Identify" ) );

	connect( ListView_OPTIONTREE, SIGNAL(clicked( QListViewItem * )), this, SLOT(slotListViewOptionClicked( QListViewItem * )) );

	connect( PushButton_BROWSESOUNDFILECONNECT, SIGNAL(clicked()), this, SLOT(slotBrowseSoundFileConnect()) );
	connect( PushButton_BROWSESOUNDFILEDISCONNECT, SIGNAL(clicked()), this, SLOT(slotBrowseSoundFileDisconnect()) );
	connect( PushButton_BROWSESOUNDFILESEND, SIGNAL(clicked()), this, SLOT(slotBrowseSoundFileSend()) );
	connect( PushButton_BROWSESOUNDFILERECEIVE, SIGNAL(clicked()), this, SLOT(slotBrowseSoundFileReceive()) );
	connect( PushButton_BROWSESOUNDFILEFIRSTRECEIVE, SIGNAL(clicked()), this, SLOT(slotBrowseSoundFileFirstReceive()) );

	connect( PushButton_PREVIEWSOUNDFILECONNECT, SIGNAL(clicked()), this, SLOT(slotPreviewSoundFileConnect()) );
	connect( PushButton_PREVIEWSOUNDFILEDISCONNECT, SIGNAL(clicked()), this, SLOT(slotPreviewSoundFileDisconnect()) );
	connect( PushButton_PREVIEWSOUNDFILESEND, SIGNAL(clicked()), this, SLOT(slotPreviewSoundFileSend()) );
	connect( PushButton_PREVIEWSOUNDFILERECEIVE, SIGNAL(clicked()), this, SLOT(slotPreviewSoundFileReceive()) );
	connect( PushButton_PREVIEWSOUNDFILEFIRSTRECEIVE, SIGNAL(clicked()), this, SLOT(slotPreviewSoundFileFirstReceive()) );

	connect( PushButton_BROWSESOUNDPLAYER, SIGNAL(clicked()), this, SLOT(slotBrowseSoundPlayer()) );
	connect( PushButton_BROWSEDOWNLOADFOLDER, SIGNAL(clicked()), this, SLOT(slotBrowseDownloadFolder()) );
	connect( PushButton_BROWSEDOWNLOADFINISHEDFOLDER, SIGNAL(clicked()), this, SLOT(slotBrowseDownloadFinishedFolder()) );
	connect( PushButton_BROWSEFILELIST, SIGNAL(clicked()), this, SLOT(slotBrowseFileList()) );
	connect( PushButton_BROWSEDATAFOLDER, SIGNAL(clicked()), this, SLOT(slotBrowseDataFolder()) );
	connect( PushButton_ADDSHAREDFOLDER, SIGNAL(clicked()), this, SLOT(slotAddSharedFolder()) );
	connect( PushButton_CREATESHARELIST, SIGNAL(clicked()), this, SLOT(slotCreateShareList()) );
	connect( PushButton_SHARELISTINFO, SIGNAL(clicked()), this, SLOT(slotShareListInfo()) );
	connect( PushButton_REMOVESHAREDFOLDER, SIGNAL(clicked()), this, SLOT(slotRemoveSharedFolder()) );
	connect( PushButton_SAVE, SIGNAL(clicked()), this, SLOT(slotSave()) );
	connect( PushButton_CANCEL, SIGNAL(clicked()), this, SLOT(reject()) );
	connect( PushButton_TESTWRONGIP, SIGNAL(clicked()), this, SLOT(slotTestWrongIp()) );
	connect( PushButton_GETINTERFACE, SIGNAL(clicked()), this, SLOT(slotGetInterface()) );
	connect( PushButton_TESTINTERFACE, SIGNAL(clicked()), this, SLOT(slotTestInterface()) );
	connect( PushButton_SETTHEME, SIGNAL(clicked()), this, SLOT(slotSetTheme()) );
	connect( PushButton_BROWSELANGUAGEFILE, SIGNAL(clicked()), this, SLOT(slotBrowseLanguageFile()) );
	connect( PushButton_BROWSEBROWSER, SIGNAL(clicked()), this, SLOT(slotBrowseBrowser()) );

	connect( PushButton_BROWSETRANSFERCERT, SIGNAL(clicked()), this, SLOT(slotBrowseTransferCert()) );
	connect( PushButton_BROWSETRANSFERKEY, SIGNAL(clicked()), this, SLOT(slotBrowseTransferKey()) );

	connect( RadioButton_ACTIVEMODE, SIGNAL(toggled(bool)), this, SLOT(slotModeActiveChange(bool)) );
	connect( RadioButton_PASSIVEMODE, SIGNAL(toggled(bool)), this, SLOT(slotModePassiveChange(bool)) );
	connect( RadioButton_WRONGIP, SIGNAL(toggled(bool)), this, SLOT(slotWrongIPChange(bool)) );
	connect( RadioButton_INTERFACEIP, SIGNAL(toggled(bool)), this, SLOT(slotInterfaceIPChange(bool)) );

	connect( PushButton_ADDHUBLISTURL, SIGNAL(clicked()), this, SLOT(slotAddHubListUrl()) );
	connect( PushButton_REMOVEHUBLISTURL, SIGNAL(clicked()), this, SLOT(slotRemoveHubListUrl()) );

	connect( PushButton_BROWSEAPPFONT, SIGNAL(clicked()), this, SLOT(slotBrowseAppFont()) );

	connect( CheckBox_SOUNDDISABLED, SIGNAL(clicked()), this, SLOT(slotDisableSound()) );
	
	connect( CheckBox_EXTERNALPLAYER, SIGNAL(clicked()), this, SLOT(slotExternalPlayer()) );
	connect( CheckBox_SOUNDPLAYCONNECT, SIGNAL(clicked()), this, SLOT(slotSoundPlayConnect()) );
	connect( CheckBox_SOUNDPLAYDISCONNECT, SIGNAL(clicked()), this, SLOT(slotSoundPlayDisconnect()) );
	connect( CheckBox_SOUNDPLAYSEND, SIGNAL(clicked()), this, SLOT(slotSoundPlaySend()) );
	connect( CheckBox_SOUNDPLAYRECEIVE, SIGNAL(clicked()), this, SLOT(slotSoundPlayRecieve()) );
	connect( CheckBox_SOUNDPLAYFIRSTRECEIVE, SIGNAL(clicked()), this, SLOT(slotSoundPlayFirstReceive()) );

	connect( PushButton_BROWSELOGFILE, SIGNAL(clicked()), this, SLOT(slotBrowseLogFile()) );

	connect( ToolButton_CHATCOLORREMOTETEXT, SIGNAL(clicked()), this, SLOT(slotChatColorRemoteText()) );
	connect( ToolButton_CHATCOLORREMOTENICK, SIGNAL(clicked()), this, SLOT(slotChatColorRemoteNick()) );

	// style options
	ComboBox_THEME->clear();

	if ( Config->GetThemeSupport() == TRUE )
	{
		QStringList list = QStyleFactory::keys();

		if ( list.count() > 0 )
		{
			list.sort();
			ComboBox_THEME->insertStringList(list);
			list.clear();
		}
	}
	else
	{
		// disable the theme support
		ComboBox_THEME->setEnabled(FALSE);
		PushButton_SETTHEME->setEnabled(FALSE);
	}
}

/** */
void DCOptions::slotSave()
{
	int tcpport, udpport;
	bool ok;

	// check if mode change
	if ( ((RadioButton_ACTIVEMODE->isOn() == TRUE) && (Config->GetMode() == ecmPassive)) ||
	     ((RadioButton_ACTIVEMODE->isOn() == FALSE) && (Config->GetMode() == ecmActive)) )
	{
		QMessageBox::warning( 0, "DC-GUI",
			QString(tr("You change the client mode ! Please restart DCGUI !")));
	}

	if ( LineEdit_DOWNLOADFOLDER->text() == "" )
	{
		QMessageBox::critical( 0, "DC-GUI",
		QString(tr("You must set a Download Folder !")));
		return;
	}

	if ( LineEdit_DOWNLOADFINISHEDFOLDER->text() == LineEdit_DOWNLOADFOLDER->text() )
	{
		QMessageBox::critical( 0, "DC-GUI",
		QString(tr("Download Finished Folder and Download Folder must be different !")));
		return;
	}

	// check active mode settings
	if ( RadioButton_ACTIVEMODE->isOn() == TRUE )
	{
		// check fake host
		if ( (RadioButton_WRONGIP->isOn() == TRUE) &&
	     	     (LineEdit_FAKEHOST->text() == "") )

		{
			QMessageBox::critical( 0, "DC-GUI",
			QString(tr("You must enter a valid 'Fake Host' !")));
			return;
		}

		// check interface
		if ( (RadioButton_INTERFACEIP->isOn() == TRUE) &&
	     	     (LineEdit_INTERFACE->text() == "") )

		{
			QMessageBox::critical( 0, "DC-GUI",
			QString(tr("You must enter a valid interface !")));
			return;
		}

		// check ports
		tcpport = LineEdit_TCPLISTENPORT->text().toInt(&ok);

		if ( (ok == FALSE) || (tcpport == 0) )
		{
			QMessageBox::critical( 0, "DC-GUI",
			QString(tr("You must enter a valid tcp listen port !")));
			return;
		}

		udpport = LineEdit_UDPLISTENPORT->text().toInt(&ok);

		if ( (ok == FALSE) || (udpport == 0) )
		{
			QMessageBox::critical( 0, "DC-GUI",
			QString(tr("You must enter a valid udp listen port !")));
			return;
		}

#ifndef WIN32
		if ( (tcpport < 1024) || (udpport < 1024) )
		{
			QMessageBox::critical( 0, "DC-GUI",
			QString(tr("You listen on a port < 1024 ! You can run dcgui only as root in active mode !")));
		}
#endif
	}

	// no nick is given
	if ( LineEdit_NICK->text() == "" )
	{
		QMessageBox::critical( 0, "DC-GUI",
		QString(tr("You must enter a valid nick !")));
		return;
	}

	// no search nick is given
	if ( LineEdit_SEARCHNICK->text() == "" )
	{
		QMessageBox::critical( 0, "DC-GUI",
		QString(tr("You must enter a valid search nick !")));
		return;
	}

	if (LineEdit_APPFONT->text() != "")
	{
		QFont font;
		if (font.fromString(LineEdit_APPFONT->text()) == TRUE)
		{
			QApplication::setFont(font, TRUE);
		}
	}

	accept();
}

/** */
void DCOptions::slotChatColorRemoteText()
{
	QColor col;

	col.setNamedColor(LineEdit_CHATCOLORREMOTETEXT->text());
	col = QColorDialog::getColor(col);
	LineEdit_CHATCOLORREMOTETEXT->setText(col.name());
}

/** */
void DCOptions::slotChatColorRemoteNick()
{
	QColor col;

	col.setNamedColor(LineEdit_CHATCOLORREMOTENICK->text());
	col = QColorDialog::getColor(col);
	LineEdit_CHATCOLORREMOTENICK->setText(col.name());
}

/** */
void DCOptions::slotWrongIPChange( bool b )
{
	GroupBox_WRONGIP->setEnabled(b);
	GroupBox_INTERFACEIP->setEnabled(!b);
}

/** */
void DCOptions::slotInterfaceIPChange( bool b )
{
	GroupBox_WRONGIP->setEnabled(!b);
	GroupBox_INTERFACEIP->setEnabled(b);
}

/** */
void DCOptions::slotModeActiveChange(bool b)
{
	ButtonGroup_ACTIVEMODESETTINGS->setEnabled(b);
	ButtonGroup_PASSIVEMODESETTINGS->setEnabled(!b);
}

/** */
void DCOptions::slotModePassiveChange(bool b)
{
	ButtonGroup_ACTIVEMODESETTINGS->setEnabled(!b);
	ButtonGroup_PASSIVEMODESETTINGS->setEnabled(b);
}

/** */
void DCOptions::slotTestWrongIp()
{
	QString sip="";
	CSocket Socket;
	CString s;

	s = LineEdit_FAKEHOST->text().ascii();
	s = s.Replace(' ',"");
	LineEdit_FAKEHOST->setText(s.Data());

	if ( s != "" )
	{
		sip = CSocket::GetHostByName(s).Data();
	}

	if ( sip != "" )
	{
		QMessageBox::information( 0, "DC-GUI", QString(tr("Host IP : "))+sip);
	}
	else
	{
		QMessageBox::critical( 0, "DC-GUI", QString(tr("Can't get Host IP !")));
	}
}

/** */
void DCOptions::slotGetInterface()
{
	CSocket Socket;
	CList<CString> interfacelist;
	CString * s;
	QStringList lst;

	if ( Socket.GetInterfaceList(&interfacelist) > 0 )
	{
		s = 0;

		while( (s=interfacelist.Next(s)) != 0 )
		{
			lst << s->Data();
		}
  
		bool ok = FALSE;

		QString res = QInputDialog::getItem(
				tr( "Interface List" ),
				tr( "Please select an interface" ), lst, 1, TRUE, &ok, this );

		if ( ok )
		{
			LineEdit_INTERFACE->setText(res);
		}
	}
	else
	{
		QMessageBox::information( 0, "DC-GUI", QString(tr("No interfaces found !")));
	}
}

/** */
void DCOptions::slotTestInterface()
{
	QString sip;
	CSocket Socket;

	sip = Socket.GetInterfaceIP(LineEdit_INTERFACE->text().ascii()).Data();

	if ( sip != "" )
	{
		QMessageBox::information( 0, "DC-GUI", QString(tr("Interface IP : "))+sip);
	}
	else
	{
		QMessageBox::critical( 0, "DC-GUI", QString(tr("Can't get interface IP !")));
	}
}

/** */
void DCOptions::slotDisableSound()
{
	bool b;

	b = !CheckBox_SOUNDDISABLED->isChecked();

	CheckBox_SOUNDDISABLEDAWAY->setEnabled(b);
	CheckBox_SOUNDPLAYCONNECT->setEnabled(b);
	CheckBox_SOUNDPLAYDISCONNECT->setEnabled(b);
	CheckBox_SOUNDPLAYSEND->setEnabled(b);
	CheckBox_SOUNDPLAYRECEIVE->setEnabled(b);
	CheckBox_SOUNDPLAYFIRSTRECEIVE->setEnabled(b);
	CheckBox_EXTERNALPLAYER->setEnabled(b);
	if (!b) {
		LineEdit_EXTERNALPLAYER->setEnabled(b);
		PushButton_BROWSESOUNDPLAYER->setEnabled(b);
		LineEdit_SOUNDFILECONNECT->setEnabled(b);
		PushButton_BROWSESOUNDFILECONNECT->setEnabled(b);
		PushButton_PREVIEWSOUNDFILECONNECT->setEnabled(b);
		LineEdit_SOUNDFILEDISCONNECT->setEnabled(b);
		PushButton_BROWSESOUNDFILEDISCONNECT->setEnabled(b);
		PushButton_PREVIEWSOUNDFILEDISCONNECT->setEnabled(b);
		LineEdit_SOUNDFILESEND->setEnabled(b);
		PushButton_BROWSESOUNDFILESEND->setEnabled(b);
		PushButton_PREVIEWSOUNDFILESEND->setEnabled(b);
		LineEdit_SOUNDFILERECEIVE->setEnabled(b);
		PushButton_BROWSESOUNDFILERECEIVE->setEnabled(b);
		PushButton_PREVIEWSOUNDFILERECEIVE->setEnabled(b);
		LineEdit_SOUNDFILEFIRSTRECEIVE->setEnabled(b);
		PushButton_BROWSESOUNDFILEFIRSTRECEIVE->setEnabled(b);
		PushButton_PREVIEWSOUNDFILEFIRSTRECEIVE->setEnabled(b);
	} else {
		slotExternalPlayer();
		slotSoundPlayConnect();
		slotSoundPlayConnect();
		slotSoundPlayDisconnect();
		slotSoundPlaySend();
		slotSoundPlayRecieve();
		slotSoundPlayFirstReceive();
	}
}

/** */
void DCOptions::slotExternalPlayer()
{
	bool b;

	b = CheckBox_EXTERNALPLAYER->isChecked();
	
	LineEdit_EXTERNALPLAYER->setEnabled(b);
	PushButton_BROWSESOUNDPLAYER->setEnabled(b);
}

/** */
void DCOptions::slotSoundPlayConnect()
{
	bool b;

	b = CheckBox_SOUNDPLAYCONNECT->isChecked();
	
	LineEdit_SOUNDFILECONNECT->setEnabled(b);
	PushButton_BROWSESOUNDFILECONNECT->setEnabled(b);
	PushButton_PREVIEWSOUNDFILECONNECT->setEnabled(b);
}

/** */
void DCOptions::slotSoundPlayDisconnect()
{
	bool b;

	b = CheckBox_SOUNDPLAYDISCONNECT->isChecked();
	
	LineEdit_SOUNDFILEDISCONNECT->setEnabled(b);
	PushButton_BROWSESOUNDFILEDISCONNECT->setEnabled(b);
	PushButton_PREVIEWSOUNDFILEDISCONNECT->setEnabled(b);
}

/** */
void DCOptions::slotSoundPlaySend()
{
	bool b;

	b = CheckBox_SOUNDPLAYSEND->isChecked();
	
	LineEdit_SOUNDFILESEND->setEnabled(b);
	PushButton_BROWSESOUNDFILESEND->setEnabled(b);
	PushButton_PREVIEWSOUNDFILESEND->setEnabled(b);
}

/** */
void DCOptions::slotSoundPlayRecieve()
{
	bool b;

	b = CheckBox_SOUNDPLAYRECEIVE->isChecked();
	
	LineEdit_SOUNDFILERECEIVE->setEnabled(b);
	PushButton_BROWSESOUNDFILERECEIVE->setEnabled(b);
	PushButton_PREVIEWSOUNDFILERECEIVE->setEnabled(b);
}

/** */
void DCOptions::slotSoundPlayFirstReceive()
{
	bool b;

	b = CheckBox_SOUNDPLAYFIRSTRECEIVE->isChecked();
	
	LineEdit_SOUNDFILEFIRSTRECEIVE->setEnabled(b);
	PushButton_BROWSESOUNDFILEFIRSTRECEIVE->setEnabled(b);
	PushButton_PREVIEWSOUNDFILEFIRSTRECEIVE->setEnabled(b);
}

/** */
void DCOptions::slotBrowseSoundPlayer()
{
	QString file;

	file = QFileDialog::getOpenFileName( "", "", this, "blf", tr("Select sound player") );

	if( file != "" )
	{
		LineEdit_EXTERNALPLAYER->setText(file);
	}
}

/** */
void DCOptions::slotBrowseTransferCert()
{
	QString file;

	file = QFileDialog::getOpenFileName( "", "", this, "blf", tr("Select transfer cert") );

	if( file != "" )
	{
		LineEdit_TRANSFERCERT->setText(file);
	}
}

/** */
void DCOptions::slotBrowseTransferKey()
{
	QString file;

	file = QFileDialog::getOpenFileName( "", "", this, "blf", tr("Select transfer key") );

	if( file != "" )
	{
		LineEdit_TRANSFERKEY->setText(file);
	}
}

/** */
void DCOptions::slotBrowseBrowser()
{
	QString file;

	file = QFileDialog::getOpenFileName( "", "", this, "blf", tr("Select a browser") );

	if( file != "" )
	{
		LineEdit_BROWSER->setText(file);
	}
}

/** */
void DCOptions::BrowseSoundFile( eUserSound usersound )
{
	QString file;
	QString filter;

	filter = tr("au")        + " (*.au);;"  +
		 tr("wav")       + " (*.wav);;" +
		 tr("All Files") + " (*)";

	file = QFileDialog::getOpenFileName( "", filter, this, "blf", tr("Select sound file") );

	if( file != "" )
	{
		switch(usersound)
		{
			case eusCONNECT:
				LineEdit_SOUNDFILECONNECT->setText(file);
				break;
			case eusDISCONNECT:
				LineEdit_SOUNDFILEDISCONNECT->setText(file);
				break;
			case eusSEND:
				LineEdit_SOUNDFILESEND->setText(file);
				break;
			case eusRECEIVE:
				LineEdit_SOUNDFILERECEIVE->setText(file);
				break;
			case eusFIRSTRECEIVE:
				LineEdit_SOUNDFILEFIRSTRECEIVE->setText(file);
				break;
			default:
				break;
		}
	}
}

/** */
void DCOptions::PreviewSoundFile( eUserSound usersound )
{
	QString file="";

	switch(usersound)
	{
		case eusCONNECT:
			file = LineEdit_SOUNDFILECONNECT->text();
			break;
		case eusDISCONNECT:
			file = LineEdit_SOUNDFILEDISCONNECT->text();
			break;
		case eusSEND:
			file = LineEdit_SOUNDFILESEND->text();
			break;
		case eusRECEIVE:
			file = LineEdit_SOUNDFILERECEIVE->text();
			break;
		case eusFIRSTRECEIVE:
			file = LineEdit_SOUNDFILEFIRSTRECEIVE->text();
			break;
		default:
			break;
	}

	Config->PlaySound( file.ascii() );
}

/** */
void DCOptions::slotBrowseDownloadFolder()
{
	QString dir;

	dir = QFileDialog::getExistingDirectory ( "", this, "bdf", tr("Select download folder"), TRUE );

	if(dir!="")
	{
		LineEdit_DOWNLOADFOLDER->setText(dir);
	}
}

/** */
void DCOptions::slotBrowseDownloadFinishedFolder()
{
	QString dir;

	dir = QFileDialog::getExistingDirectory ( "", this, "bdf", tr("Select download finished folder"), TRUE );

	if(dir!="")
	{
		LineEdit_DOWNLOADFINISHEDFOLDER->setText(dir);
	}
}

/** */
void DCOptions::slotBrowseDataFolder()
{
	QString dir;

	dir = QFileDialog::getExistingDirectory ( "", this, "bdf", tr("Select data folder"), TRUE );

	if( dir != "" )
	{
		LineEdit_DATAFOLDER->setText(dir);
	}
}

/** */
void DCOptions::slotBrowseFileList()
{
	DCFileBrowser *bft;
	CHE3 *he3=0;
	CByteArray ba;
	CString * s=0;

	if ( Config->GetShareBuffer( esbtHE3, &ba ) == 0 )
	{
		he3 = new CHE3();
		s = he3->decode_he3_data(&ba);
		delete he3;

		if ( s != 0 )
		{
			QDialog *d = new QDialog(this);
			QGridLayout *Layout = new QGridLayout( d, 1, 1, 4, 4, "Layout"); 
//			bft = new DCBrowseFileTree( d, "browsefiletree", 0, TRUE );
			bft = new DCFileBrowser( d, "browsefiletree" );
			Layout->addWidget( bft, 0, 0 );

			// set transfer
			d->setCaption( tr("My") + " - Filebrowser" );
			bft->InitTree("","","",s->Data());
			bft->layout()->setSpacing(0);
			bft->layout()->setMargin(0);
			d->exec();
			delete d;

			delete s;
		}
	}	
}

/** */
void DCOptions::slotBrowseLogFile()
{
	QString logfile;

	logfile = QFileDialog::getSaveFileName ( "", "", this, 0, tr("Select log file") );

	if( !logfile.isEmpty() )
	{
		LineEdit_LOGFILENAME->setText(logfile);
	}
}

/** */
void DCOptions::slotAddSharedFolder()
{
	QString dir;

	dir = QFileDialog::getExistingDirectory ( "", this, "bdf", tr("Select share folder"), TRUE );

	if( dir != "" )
	{
		if ( ListBox_SHAREDFOLDERS->findItem(dir) == 0 )
		{
			ListBox_SHAREDFOLDERS->insertItem(dir);
		}
	}
}

/** */
void DCOptions::slotRemoveSharedFolder()
{
	int i;

	i = ListBox_SHAREDFOLDERS->currentItem();

	if ( i != -1 )
	{
		ListBox_SHAREDFOLDERS->removeItem(i);
	}
}

/** */
void DCOptions::SetValues()
{
	int i;
	CList<CString> list;
	CString *s;

	LineEdit_NICK->setText(Config->GetNick().Data());
	LineEdit_SEARCHNICK->setText(Config->GetSearchNick().Data());
	TextEdit_AWAYMESSAGE->setText(QString(Config->GetAwayMessage().Data()).replace( QRegExp("\\r"), "" ));
	LineEdit_DESCRIPTION->setText(Config->GetDescription(TRUE).Data());
	CheckBox_DESCRIPTION_TAG->setChecked(Config->GetDescriptionTag());
	LineEdit_EMAIL->setText(Config->GetEMail(TRUE).Data());
	CheckBox_ANTISPAM->setChecked(Config->GetAntiSpam());
	CheckBox_SHOWVERSIONTAG->setChecked(Config->GetShowVersionTag());
	CheckBox_USERLISTRIGHTALIGNMENT->setChecked(Config->GetUserListRightAlignment());
	CheckBox_CHECKPRIVATEADDRESSSPACE->setChecked(Config->GetCheckPrivateAddressSpace());
	CheckBox_SHOWCHATSENDBUTTON->setChecked(Config->GetShowChatSendButton());
	LineEdit_BROWSER->setText(Config->GetBrowser().Data());
	CheckBox_DYNAMICUPLOADRATE->setChecked(Config->GetDynamicUploadRate());
	CheckBox_SHOWCHATINTAB->setChecked(Config->GetShowChatInTab());
	LineEdit_CHATCOLORREMOTETEXT->setText(Config->GetChatColor(eccREMOTETEXT).Data());
	LineEdit_CHATCOLORREMOTENICK->setText(Config->GetChatColor(eccREMOTENICK).Data());
	SpinBox_CHATMAXPARAGRAPH->setValue(Config->GetChatMaxParagraph());
	CheckBox_CLIENTWINDOWSMINIMIZED->setChecked(Config->GetOpenClientWindowsMinimized());
	CheckBox_TRANSFERAUTOSEARCH->setChecked(Config->GetTransferAutoSearch());

	CheckBox_CHATSENDOFFLINEMESSAGES->setChecked(Config->GetChatSendOfflineMessages());
	CheckBox_CHATRECVOFFLINEMESSAGES->setChecked(Config->GetChatRecvOfflineMessages());

	for(i=0;i<ComboBox_SPEED->count();i++)
	{
		if ( ComboBox_SPEED->text(i) == Config->GetSpeed() )
		{
			ComboBox_SPEED->setCurrentItem(i);
			break;
		}
	}

	LineEdit_DOWNLOADFOLDER->setText(Config->GetDownloadFolder().Data());
	LineEdit_DOWNLOADFINISHEDFOLDER->setText(Config->GetDownloadFinishedFolder().Data());
	LineEdit_DATAFOLDER->setText(Config->GetDatadir().Data());

	CheckBox_AUTORECREATESHARELIST->setChecked(Config->GetAutoRecreateShareList());

	LineEdit_FLOODOPKICKMESSAGE->setText(QString(Config->GetFloodOpKickMessage().Data()).replace( QRegExp("\\r"), "" ));
	SpinBox_FLOODCOUNT->setValue(Config->GetFloodCount());
	CheckBox_FLOODOPKICK->setChecked(Config->GetFloodOpKick());
	
	// save shared folders
	ListBox_SHAREDFOLDERS->clear();

	Config->GetSharedFolders(&list);

	s = 0;
	while( (s=list.Next(s)) != 0 )	
	{
		ListBox_SHAREDFOLDERS->insertItem((*s).Data());
	}

	SpinBox_MAXUPLOADRATE->setValue( Config->GetMaxUploadRate() );
	SpinBox_MAXDOWNLOADRATE->setValue( Config->GetMaxDownloadRate() );

	SpinBox_MAXSIMULTANEOUSUPLOADS->setValue( Config->GetMaxUpload() );
	SpinBox_SAVEDOWNLOADQUEUETIME->setValue( Config->GetDownloadQueueTime() );

	LineEdit_TCPLISTENPORT->setText( QString().setNum(Config->GetTCPListenPort()) );
	LineEdit_UDPLISTENPORT->setText( QString().setNum(Config->GetUDPListenPort()) );

	if ( Config->GetFakeHost() == 1 )
	{
		RadioButton_WRONGIP->setChecked(TRUE);
		slotWrongIPChange(TRUE);
	}
	else
	{
		RadioButton_INTERFACEIP->setChecked(TRUE);
		slotWrongIPChange(FALSE);
	}

	if ( Config->GetMode() == ecmPassive )
	{
		RadioButton_PASSIVEMODE->setChecked(TRUE);
		slotModeActiveChange(FALSE);
	}
	else
	{
		RadioButton_ACTIVEMODE->setChecked(TRUE);
		slotModeActiveChange(TRUE);
	}

	CheckBox_SENDMESSAGEONACTIVEMODEREQUEST->setChecked( Config->GetSendMessageOnActiveModeRequest() );

	LineEdit_FAKEHOST->setText(Config->GetHost().Data());
	LineEdit_INTERFACE->setText(Config->GetInterface().Data());

	// gui settings
	CheckBox_OPENPRIVATECHATWINDOW->setChecked(Config->GetOpenPrivateChatWindow());
	CheckBox_EMOTICONS->setChecked(Config->GetEnableEmoticons());
	
	switch(Config->GetUnit())
	{
		case euBYTE:
			RadioButton_UNITBYTE->setChecked(TRUE);
			break;
		case euKBYTE:
			RadioButton_UNITKBYTE->setChecked(TRUE);
			break;
		case euMBYTE:
			RadioButton_UNITMBYTE->setChecked(TRUE);
			break;
		case euGBYTE:
			RadioButton_UNITGBYTE->setChecked(TRUE);
			break;
		default:
			RadioButton_UNITAUTO->setChecked(TRUE);
			break;
	}

	for(i=0;i<ComboBox_THEME->count();i++)
	{
		if ( Config->GetTheme() == CString(ComboBox_THEME->text(i).ascii()) )
		{
			ComboBox_THEME->setCurrentItem(i);
			break;
		}
	}
	for(i=0;i<ComboBox_SENDCHAT->count();i++)
	{
		if ( Config->GetSendChat() == CString(ComboBox_SENDCHAT->text(i).ascii()) )
		{
			ComboBox_SENDCHAT->setCurrentItem(i);
			break;
		}
	}
	
	LineEdit_LANGUAGEFILE->setText( Config->GetLanguageFile().Data() );
	CheckBox_SHOWSTATUSMESSAGE->setChecked( Config->GetShowStatusMessage() );
	CheckBox_QUERYONEXIT->setChecked( Config->GetQueryOnExit() );
	CheckBox_SENDHIDEPRIVATECHATTOPUBLICCHAT->setChecked( Config->GetSendHidePrivateChatToPublicChat());
	SpinBox_CHATMESSAGEMAXLINES->setValue( Config->GetChatMessageMaxLines() );

	// sound settings
	LineEdit_SOUNDFILECONNECT->setText( Config->GetSoundFile(eusCONNECT).Data() );
	LineEdit_SOUNDFILEDISCONNECT->setText( Config->GetSoundFile(eusDISCONNECT).Data() );
	LineEdit_SOUNDFILESEND->setText( Config->GetSoundFile(eusSEND).Data() );
	LineEdit_SOUNDFILERECEIVE->setText( Config->GetSoundFile(eusRECEIVE).Data() );
	LineEdit_SOUNDFILEFIRSTRECEIVE->setText( Config->GetSoundFile(eusFIRSTRECEIVE).Data() );

	CheckBox_SOUNDDISABLED->setChecked(Config->GetSoundDisabled());
	CheckBox_SOUNDDISABLEDAWAY->setChecked(Config->GetSoundDisabledAway());

	CheckBox_SOUNDPLAYCONNECT->setChecked(Config->GetSoundEnabled(eusCONNECT));
	CheckBox_SOUNDPLAYDISCONNECT->setChecked(Config->GetSoundEnabled(eusDISCONNECT));
	CheckBox_SOUNDPLAYSEND->setChecked(Config->GetSoundEnabled(eusSEND));
	CheckBox_SOUNDPLAYRECEIVE->setChecked(Config->GetSoundEnabled(eusRECEIVE));
	CheckBox_SOUNDPLAYFIRSTRECEIVE->setChecked(Config->GetSoundEnabled(eusFIRSTRECEIVE));

	CheckBox_EXTERNALPLAYER->setChecked(Config->GetExternalSoundPlayer());
	LineEdit_EXTERNALPLAYER->setText( Config->GetExternalPlayer().Data() );

	LineEdit_APPFONT->setText( Config->GetAppFont().Data() );

	// log settings
	CheckBox_TIMESTAMPPRIVATECHAT->setChecked(Config->GetTimeStamp(etsPRIVATECHAT));
	CheckBox_TIMESTAMPHUBCHAT->setChecked(Config->GetTimeStamp(etsHUBCHAT));
	CheckBox_LOGFILE->setChecked(Config->GetLogFile());
	LineEdit_LOGFILENAME->setText( Config->GetLogFileName().Data() );

	// other settings
	CheckBox_HUBLISTSTORELOCAL->setChecked(Config->GetHubListStoreLocal());
	SpinBox_RECONNECTCOUNT->setValue(Config->GetReconnectCount());
	SpinBox_RECONNECTTIMEOUT->setValue(Config->GetReconnectTimeout());
	SpinBox_TRANSFERRESENDTIMEOUT->setValue(Config->GetTransferResendTimeout());
	SpinBox_TRANSFERRESPONSETIMEOUT->setValue(Config->GetTransferResponseTimeout());
	CheckBox_FORCEMOVEENABLED->setChecked(Config->GetForceMoveEnabled());
	SpinBox_RELOADHUBLISTTIME->setValue(Config->GetReloadHubListTime());

	// transfer view settings
	CheckBox_TV_PERCENTCHUNK->setChecked(Config->GetTransferViewOptions(etvoCHUNKPERCENT));
	CheckBox_TV_PERCENTFILE->setChecked(Config->GetTransferViewOptions(etvoFILEPERCENT));
	CheckBox_TV_CHUNKSIZE->setChecked(Config->GetTransferViewOptions(etvoCHUNKSIZE));
	CheckBox_TV_FILESIZE->setChecked(Config->GetTransferViewOptions(etvoFILESIZE));
	CheckBox_TV_DOWNLOADRATESINGLE->setChecked(Config->GetTransferViewOptions(etvoDOWNLOADRATESINGLE));
	CheckBox_TV_ELAPSEDTIMESINGLE->setChecked(Config->GetTransferViewOptions(etvoELAPSEDTIMESINGLE));
	CheckBox_TV_DOWNLOADRATEMULTI->setChecked(Config->GetTransferViewOptions(etvoDOWNLOADRATEMULTI));
	CheckBox_TV_ELAPSEDTIMEMULTI->setChecked(Config->GetTransferViewOptions(etvoELAPSEDTIMEMULTI));
	SpinBox_USERUPLOADSLOTS->setValue(Config->GetUserUploadSlots());

	switch ( Config->GetHubOfflineTransferClose() )
	{
		case ectNONE:
			RadioButton_NONE->setChecked(TRUE);
			break;
		case ectUPLD:
			RadioButton_UPLOAD->setChecked(TRUE);
			break;
		case ectDLD:
			RadioButton_DOWNLOAD->setChecked(TRUE);
			break;
		case ectBOTH:
			RadioButton_BOTH->setChecked(TRUE);
			break;
	}
	
	LineEdit_TRANSFERCERT->setText(Config->GetTransferCert().Data());
	LineEdit_TRANSFERKEY->setText(Config->GetTransferKey().Data());

	CList<DCConfigHubListUrl> hublisturllist;
	Config->GetHubListUrlList(&hublisturllist);

	DCConfigHubListUrl * hublisturl = 0;

	while( (hublisturl=hublisturllist.Next(hublisturl)) != 0 )
	{
		QCheckListItem * cli = new QCheckListItem( ListView_HUBLISTURL, hublisturl->sUrl.Data(), QCheckListItem::CheckBox );
		cli->setOn(hublisturl->bEnabled);
	}

	// init the sound tab
	slotDisableSound();
}

/** */
void DCOptions::GetValues()
{
	bool ok;
	unsigned int i;
	CList<CString> sharedfolders;

	Config->SetNick(LineEdit_NICK->text().ascii());
	Config->SetSearchNick(LineEdit_SEARCHNICK->text().ascii());
	Config->SetAwayMessage(TextEdit_AWAYMESSAGE->text().replace( QRegExp("\\n"), "\xd\xa" ).ascii());
	Config->SetDescription(LineEdit_DESCRIPTION->text().ascii());
	Config->SetDescriptionTag(CheckBox_DESCRIPTION_TAG->isChecked());
	Config->SetEMail(LineEdit_EMAIL->text().ascii());
	Config->SetAntiSpam(CheckBox_ANTISPAM->isChecked());
	Config->SetShowVersionTag(CheckBox_SHOWVERSIONTAG->isChecked());
	Config->SetUserListRightAlignment(CheckBox_USERLISTRIGHTALIGNMENT->isChecked());
	Config->SetCheckPrivateAddressSpace(CheckBox_CHECKPRIVATEADDRESSSPACE->isChecked());
	Config->SetShowChatSendButton(CheckBox_SHOWCHATSENDBUTTON->isChecked());
	Config->SetBrowser(LineEdit_BROWSER->text().ascii());
	Config->SetDynamicUploadRate(CheckBox_DYNAMICUPLOADRATE->isChecked());
	Config->SetShowChatInTab(CheckBox_SHOWCHATINTAB->isChecked());
	Config->SetChatColor(eccREMOTETEXT,LineEdit_CHATCOLORREMOTETEXT->text().ascii());
	Config->SetChatColor(eccREMOTENICK,LineEdit_CHATCOLORREMOTENICK->text().ascii());
	Config->SetChatMaxParagraph(SpinBox_CHATMAXPARAGRAPH->value());
	Config->SetOpenClientWindowsMinimized(CheckBox_CLIENTWINDOWSMINIMIZED->isChecked());
	Config->SetTransferAutoSearch(CheckBox_TRANSFERAUTOSEARCH->isChecked());

	Config->SetSpeed(ComboBox_SPEED->currentText().ascii());
	Config->SetDownloadFolder(LineEdit_DOWNLOADFOLDER->text().ascii());
	Config->SetDownloadFinishedFolder(LineEdit_DOWNLOADFINISHEDFOLDER->text().ascii());
	Config->SetDatadir(LineEdit_DATAFOLDER->text().ascii());
	
	Config->SetAutoRecreateShareList(CheckBox_AUTORECREATESHARELIST->isChecked());

	Config->SetFloodOpKickMessage(LineEdit_FLOODOPKICKMESSAGE->text().replace( QRegExp("\\n"), "\xd\xa" ).ascii());
	Config->SetFloodCount(SpinBox_FLOODCOUNT->value());
	Config->SetFloodOpKick(CheckBox_FLOODOPKICK->isChecked());

	Config->SetTransferCert(LineEdit_TRANSFERCERT->text().ascii());
	Config->SetTransferKey(LineEdit_TRANSFERKEY->text().ascii());

	sharedfolders.Clear();

	for(i=0;i<ListBox_SHAREDFOLDERS->count();i++)
	{
		sharedfolders.Add( new CString(ListBox_SHAREDFOLDERS->text(i).ascii()) );
	}

	Config->SetSharedFolders( &sharedfolders );

	Config->SetMaxUpload( SpinBox_MAXSIMULTANEOUSUPLOADS->value() );
	Config->SetMaxUploadRate( SpinBox_MAXUPLOADRATE->value() );
	Config->SetMaxDownloadRate( SpinBox_MAXDOWNLOADRATE->value() );
	Config->SetDownloadQueueTime(SpinBox_SAVEDOWNLOADQUEUETIME->value());

	Config->SetTCPListenPort(LineEdit_TCPLISTENPORT->text().toInt(&ok));
	Config->SetUDPListenPort(LineEdit_UDPLISTENPORT->text().toInt(&ok));
	Config->SetFakeHost(RadioButton_WRONGIP->isOn());

	if ( RadioButton_ACTIVEMODE->isOn() )
		Config->SetMode(ecmActive);
	else
		Config->SetMode(ecmPassive);

	Config->SetHost(LineEdit_FAKEHOST->text().ascii());
	Config->SetInterface(LineEdit_INTERFACE->text().ascii());
	Config->SetSendMessageOnActiveModeRequest(CheckBox_SENDMESSAGEONACTIVEMODEREQUEST->isChecked());

	// gui settings
	Config->SetOpenPrivateChatWindow(CheckBox_OPENPRIVATECHATWINDOW->isChecked());
	Config->SetEnableEmoticons(CheckBox_EMOTICONS->isChecked());
	
	if ( RadioButton_UNITBYTE->isChecked() )
		Config->SetUnit(euBYTE);
	else if ( RadioButton_UNITKBYTE->isChecked() )
		Config->SetUnit(euKBYTE);
	else if ( RadioButton_UNITMBYTE->isChecked() )
		Config->SetUnit(euMBYTE);
	else if ( RadioButton_UNITGBYTE->isChecked() )
		Config->SetUnit(euGBYTE);
	else
		Config->SetUnit(euAUTO);
	
	Config->SetTheme(ComboBox_THEME->currentText().ascii());
	Config->SetSendChat(ComboBox_SENDCHAT->currentText().ascii());
	Config->SetLanguageFile(LineEdit_LANGUAGEFILE->text().ascii());
	Config->SetShowStatusMessage(CheckBox_SHOWSTATUSMESSAGE->isChecked());
	Config->SetQueryOnExit(CheckBox_QUERYONEXIT->isChecked());
	Config->SetSendHidePrivateChatToPublicChat(CheckBox_SENDHIDEPRIVATECHATTOPUBLICCHAT->isChecked());
	Config->SetChatSendOfflineMessages(CheckBox_CHATSENDOFFLINEMESSAGES->isChecked());
	Config->SetChatRecvOfflineMessages(CheckBox_CHATRECVOFFLINEMESSAGES->isChecked());
	Config->SetChatMessageMaxLines( SpinBox_CHATMESSAGEMAXLINES->value() );

	// sound settings
	Config->SetSoundDisabled(CheckBox_SOUNDDISABLED->isChecked());
	Config->SetSoundDisabledAway(CheckBox_SOUNDDISABLEDAWAY->isChecked());

	Config->SetSoundEnabled(eusCONNECT,CheckBox_SOUNDPLAYCONNECT->isChecked());
	Config->SetSoundEnabled(eusDISCONNECT,CheckBox_SOUNDPLAYDISCONNECT->isChecked());
	Config->SetSoundEnabled(eusSEND,CheckBox_SOUNDPLAYSEND->isChecked());
	Config->SetSoundEnabled(eusRECEIVE,CheckBox_SOUNDPLAYRECEIVE->isChecked());
	Config->SetSoundEnabled(eusFIRSTRECEIVE,CheckBox_SOUNDPLAYFIRSTRECEIVE->isChecked());

	Config->SetExternalSoundPlayer(CheckBox_EXTERNALPLAYER->isChecked());
	Config->SetExternalPlayer(LineEdit_EXTERNALPLAYER->text().ascii());
	Config->SetSoundFile( eusCONNECT, LineEdit_SOUNDFILECONNECT->text().ascii());
	Config->SetSoundFile( eusDISCONNECT, LineEdit_SOUNDFILEDISCONNECT->text().ascii());
	Config->SetSoundFile( eusSEND, LineEdit_SOUNDFILESEND->text().ascii());
	Config->SetSoundFile( eusRECEIVE, LineEdit_SOUNDFILERECEIVE->text().ascii());
	Config->SetSoundFile( eusFIRSTRECEIVE, LineEdit_SOUNDFILEFIRSTRECEIVE->text().ascii());

	Config->SetAppFont(LineEdit_APPFONT->text().ascii());

	// log settings
	Config->SetTimeStamp(etsPRIVATECHAT,CheckBox_TIMESTAMPPRIVATECHAT->isChecked());
	Config->SetTimeStamp(etsHUBCHAT,CheckBox_TIMESTAMPHUBCHAT->isChecked());
	Config->SetLogFile(CheckBox_LOGFILE->isChecked());
	Config->SetLogFileName( LineEdit_LOGFILENAME->text().ascii() );

	// other settings
	Config->SetHubListStoreLocal(CheckBox_HUBLISTSTORELOCAL->isChecked());
	Config->SetReconnectCount( SpinBox_RECONNECTCOUNT->value() );
	Config->SetReconnectTimeout( SpinBox_RECONNECTTIMEOUT->value() );
	Config->SetTransferResendTimeout(SpinBox_TRANSFERRESENDTIMEOUT->value());
	Config->SetTransferResponseTimeout(SpinBox_TRANSFERRESPONSETIMEOUT->value());
	Config->SetForceMoveEnabled(CheckBox_FORCEMOVEENABLED->isChecked());
	Config->SetReloadHubListTime(SpinBox_RELOADHUBLISTTIME->value());

	// transfer view settings
	Config->SetTransferViewOptions(etvoCHUNKPERCENT,CheckBox_TV_PERCENTCHUNK->isChecked());
	Config->SetTransferViewOptions(etvoFILEPERCENT,CheckBox_TV_PERCENTFILE->isChecked());
	Config->SetTransferViewOptions(etvoCHUNKSIZE,CheckBox_TV_CHUNKSIZE->isChecked());
	Config->SetTransferViewOptions(etvoFILESIZE,CheckBox_TV_FILESIZE->isChecked());
	Config->SetTransferViewOptions(etvoDOWNLOADRATESINGLE,CheckBox_TV_DOWNLOADRATESINGLE->isChecked());
	Config->SetTransferViewOptions(etvoELAPSEDTIMESINGLE,CheckBox_TV_ELAPSEDTIMESINGLE->isChecked());
	Config->SetTransferViewOptions(etvoDOWNLOADRATEMULTI,CheckBox_TV_DOWNLOADRATEMULTI->isChecked());
	Config->SetTransferViewOptions(etvoELAPSEDTIMEMULTI,CheckBox_TV_ELAPSEDTIMEMULTI->isChecked());
	Config->SetUserUploadSlots(SpinBox_USERUPLOADSLOTS->value());

        if ( RadioButton_NONE->isChecked() )
		Config->SetHubOfflineTransferClose( ectNONE );
	else if ( RadioButton_UPLOAD->isChecked() )
		Config->SetHubOfflineTransferClose( ectUPLD );
	else if ( RadioButton_DOWNLOAD->isChecked() )
		Config->SetHubOfflineTransferClose( ectDLD );
	else if ( RadioButton_BOTH->isChecked() )
		Config->SetHubOfflineTransferClose( ectBOTH );

	CList<DCConfigHubListUrl> hublisturllist;

	QCheckListItem * cli = (QCheckListItem*)ListView_HUBLISTURL->firstChild();

	while(cli)
	{
		DCConfigHubListUrl * hublisturl = new DCConfigHubListUrl();

		hublisturl->sUrl     = cli->text(0);
		hublisturl->bEnabled = cli->isOn();

		hublisturllist.Add(hublisturl);

		cli = (QCheckListItem*)cli->nextSibling();
	}

	Config->SetHubListUrlList(&hublisturllist);
}

/** */
void DCOptions::slotCreateShareList()
{
        unsigned int i;
	CList<CString> sharedfolders;

	// save shared folders
	sharedfolders.Clear();

	for(i=0;i<ListBox_SHAREDFOLDERS->count();i++)
	{
		sharedfolders.Add( new CString(ListBox_SHAREDFOLDERS->text(i).ascii()) );
	}

	Config->SetSharedFolders( &sharedfolders );

	if ( CFileManager::Instance() )
	{
		CFileManager::Instance()->CreateShareList();
	}
}

/** */
void DCOptions::slotShareListInfo()
{
	QString s;

	if ( Config->GetShareSize() == 0 )
	{
		s = tr("Share list not available");
	}
	else
	{
		s = tr("Compressed list size (HE3/BZ): ") +
			QString().setNum(Config->GetShareBufferSize(esbtHE3)) + "/" +
			QString().setNum(Config->GetShareBufferSize(esbtBZ)) + " " +
			tr("bytes") + "\n" +
			tr("Total shared: ") +
			DCFileTool::GetSizeString(Config->GetShareSize()).Data();
	}

	QMessageBox::information( this, tr("Share List Info"), s );
}

/** */
void DCOptions::slotSetTheme()
{
	QString s;

	if ( Config->GetThemeSupport() == TRUE )
	{
		s = ComboBox_THEME->currentText();

		if ( s != "" )
		{
			QApplication::setStyle(s);
		}
	}
}

/** */
void DCOptions::slotBrowseLanguageFile()
{
	QString file;

	file = QFileDialog::getOpenFileName( "", "Language File (*.qm)", this, "blf", tr("Select language file") );

	if( file != "" )
	{
		LineEdit_LANGUAGEFILE->setText(file);
	}
}

void DCOptions::slotBrowseAppFont()
{
  bool ok;
  QFont font = QFontDialog::getFont(&ok, QApplication::font(), this);
  if (ok == TRUE)
  {
	LineEdit_APPFONT->setText(font.toString());
  }
}

/** */
void DCOptions::slotAddHubListUrl()
{
	bool ok = FALSE;
	QString url;

	url = QInputDialog::getText(
		tr("HubList URL"),
		tr("Please enter a url"),
		QLineEdit::Normal, QString::null, &ok, this );

	if (ok)
	{
		new QCheckListItem( ListView_HUBLISTURL, url, QCheckListItem::CheckBox );
	}
}

/** */
void DCOptions::slotRemoveHubListUrl()
{
	QListViewItem * item = ListView_HUBLISTURL->currentItem();

	if (item)
	{
		ListView_HUBLISTURL->takeItem(item);
		delete item;
	}
}

/** */
void DCOptions::slotListViewOptionClicked( QListViewItem * item )
{
	if ( item == plviDCGUI )
	{
		TabWidget_DCGUI->setCurrentPage(0);
	}
	else if ( item == plviDCGUIIdentify )
	{
		TabWidget_DCGUI->setCurrentPage(0);
	}
	else if ( item == plviConnection )
	{
		TabWidget_DCGUI->setCurrentPage(1);
		TabWidget_CONNECTION->setCurrentPage(0);
	}
	else if ( item == plviConnectionMode )
	{
		TabWidget_DCGUI->setCurrentPage(1);
		TabWidget_CONNECTION->setCurrentPage(0);
	}
	else if ( item == plviConnectionSettings )
	{
		TabWidget_DCGUI->setCurrentPage(1);
		TabWidget_CONNECTION->setCurrentPage(1);
	}
	else if ( item == plviTransfer )
	{
		TabWidget_DCGUI->setCurrentPage(2);
		TabWidget_TRANSFER->setCurrentPage(0);
	}
	else if ( item == plviTransferFolder )
	{
		TabWidget_DCGUI->setCurrentPage(2);
		TabWidget_TRANSFER->setCurrentPage(0);
	}
	else if ( item == plviTransferSettings )
	{
		TabWidget_DCGUI->setCurrentPage(2);
		TabWidget_TRANSFER->setCurrentPage(1);
	}
	else if ( item == plviGUI )
	{
		TabWidget_DCGUI->setCurrentPage(3);
		TabWidget_GUI->setCurrentPage(0);
	}
	else if ( item == plviGUIUser )
	{
		TabWidget_DCGUI->setCurrentPage(3);
		TabWidget_GUI->setCurrentPage(3);
	}
	else if ( item == plviGUIChat )
	{
		TabWidget_DCGUI->setCurrentPage(3);
		TabWidget_GUI->setCurrentPage(2);
	}
	else if ( item == plviGUITransfer )
	{
		TabWidget_DCGUI->setCurrentPage(3);
		TabWidget_GUI->setCurrentPage(1);
	}
	else if ( item == plviGUIGeneral )
	{
		TabWidget_DCGUI->setCurrentPage(3);
		TabWidget_GUI->setCurrentPage(0);
	}
	else if ( item == plviSound )
	{
		TabWidget_DCGUI->setCurrentPage(4);
	}
	else if ( item == plviLog )
	{
		TabWidget_DCGUI->setCurrentPage(5);
	}
	else if ( item == plviOther )
	{
		TabWidget_DCGUI->setCurrentPage(6);
	}
	else if ( item == plviSecurity )
	{
		TabWidget_DCGUI->setCurrentPage(7);
	}
}

